import java.io.*;
import java.awt.*;
import java.net.*;
import java.applet.AudioClip;
import java.util.Vector;
import java.util.StringTokenizer;
import java.awt.image.*;
import java.awt.image.PixelGrabber;

public class News extends java.applet.Applet implements Runnable{
	Image pic, dblbuffer;
	
	boolean firstinit = false;
	
	Color colBackground, colFont, colStandard, colURL, colHighlitedURL, colTitle;

	Graphics doublebufferG;

	int width, height;
	Thread frame;
	
	int i = 0;
	
	int lineCnt = 0;
	int linesHavePlace = 0;

	Vector news;
	
	Font ftStandard, ftTitle, ftURL;
	FontMetrics fm;

	int lineHeight = 0;
	int intDrawPos = 0;
	int mousePos = 0;
	int oldmouseY = 0;
	int olddrawPos = 0;
	
	int dblbuffer_Height = 0;
	
	int intLeftSpace = 5;
	
	boolean isMouseOverURL;
	Line lActiveLine;
	
	Vector vLines;
	
	public void init(){
		
		width = size().width; 
		height = size().height; 
		
		dblbuffer=createImage(width, height);
		doublebufferG=dblbuffer.getGraphics();
		
		firstinit=true;
		repaint();
	}
	
	private Color parseColor(StringTokenizer s){
		Color c = new Color(Integer.parseInt(s.nextToken()), Integer.parseInt(s.nextToken()), Integer.parseInt(s.nextToken()));
		return c;
	}
	
	public void printStateMsg(Graphics g, Color backc, Color forec, String s){
			doublebufferG.setColor(backc);
			doublebufferG.fillRect(0,0,width,height);
			doublebufferG.setColor(forec);
			doublebufferG.drawString(s, 5, 30);
			doublebufferG.drawString("Loading...", 5, 60);
			doublebufferG.drawString("(C) Swissource GmbH", 5, 90);
			g.drawImage(dblbuffer, 0, 0, this);
	}

	
	private boolean sepInit(Graphics g){

//		backc = new Color(255,255,255);
//		forec = new Color(0,0,0);
		
		try{	
			colBackground = parseColor(new StringTokenizer(getParameter("colBackground"), ","));
			colFont = parseColor(new StringTokenizer(getParameter("colFont"), ","));
			
			colURL = parseColor(new StringTokenizer(getParameter("colURL"), ","));
			colHighlitedURL = parseColor(new StringTokenizer(getParameter("colHighlitedURL"), ","));
			
			colTitle = parseColor(new StringTokenizer(getParameter("colTitle"), ","));
			
		}catch(Exception e){System.out.println(e.toString());}

		ftStandard = new Font("Arial", 0, 12);
		ftTitle = new Font("Arial", 0, 12);
		ftURL = new Font("Arial", 0, 12);
		
		StringTokenizer st;
		try{	
			st = new StringTokenizer(getParameter("ftStandard"), ",");
			ftStandard = new Font(st.nextToken(), Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()));

			st = new StringTokenizer(getParameter("ftTitle"), ",");
			ftTitle = new Font(st.nextToken(), Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()));

			st = new StringTokenizer(getParameter("ftURL"), ",");
			ftURL = new Font(st.nextToken(), Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()));
		}catch(Exception e){System.out.println(e.toString());}
		
		fm = getFontMetrics(ftStandard);
		//Linienhhe definieren
		lineHeight = (fm.getAscent()+fm.getDescent());
		
		printStateMsg(g, colBackground, colFont, "Loading Background");

		try{
			MediaTracker media = new MediaTracker(this);
			pic = getImage(getDocumentBase(), getParameter("backPicture"));
		
			media.addImage(pic, 0);
			try {
				media.waitForAll();
			}catch(InterruptedException e){System.out.println("Graphics loading Error");}
		}catch(Exception e){System.out.println(e.toString());}

		printStateMsg(g, colBackground, colFont, "Reading News");

		try{		
			vLines = new Vector();
			lineCnt = readNews(vLines);
		
			System.out.println(lineCnt);
			
			//dblbuffer_Height = height + 2*lineCnt*lineHeight;
		
			dblbuffer_Height = height;
	    
			dblbuffer=createImage(width, dblbuffer_Height);
			doublebufferG=dblbuffer.getGraphics();
		
			linesHavePlace = (height / lineHeight) + 2;
				
			intDrawPos = height + lineHeight;
			frame=new Thread(this);
			frame.start();
			
		}catch(Exception e){System.out.println(e.toString());}
		
		
		firstinit = false;
		return true;
	}
	
	String temp = new String("");
		

	public void run(){
		while (frame != null) {
			intDrawPos--;
			
			if(intDrawPos < -lineCnt*lineHeight){
				intDrawPos = height + lineHeight;
			}
			
			repaint();
			
			try{frame.sleep(100);}catch(Exception e){}
		}
		frame = null;
	}

	public boolean handleEvent(Event event){
	
		boolean myReturn = false;
		
		if(event.id == Event.MOUSE_ENTER){
			frame.stop();
			myReturn = true;
		}else if(event.id == Event.MOUSE_EXIT){
			frame=new Thread(this);
			frame.start();
			myReturn = true;
		}else if(event.id == Event.MOUSE_DRAG){
			intDrawPos = olddrawPos - (oldmouseY-event.y);
			repaint();
			myReturn = true;
		}else if(event.id == Event.MOUSE_DOWN){
		
			if(isMouseOverURL){

				URL u = getDocumentBase();
				try{
					if((lActiveLine.strURL).indexOf("://") != -1){
						this.getAppletContext().showDocument(new URL(lActiveLine.strURL), lActiveLine.strTarget);								
					}else{
						this.getAppletContext().showDocument(new URL(u, lActiveLine.strURL), lActiveLine.strTarget);								
					}
				}catch(Exception e){e.printStackTrace();}

				isMouseOverURL = false;
				lActiveLine.setSelected(false);
			}else{
				oldmouseY = event.y;
				olddrawPos = intDrawPos;
			}
			
			myReturn = true;
		}else if(event.id == Event.MOUSE_MOVE){
			
			isMouseOverURL = false;
			
			for(int ln=0; ln < vLines.size(); ln++){
				Line l = (Line)vLines.elementAt(ln);

				if(l.isMouseOver(event, intDrawPos)){
					lActiveLine = l;
					l.setSelected(true);
					isMouseOverURL = true;
				}else
					l.setSelected(false);
			}
			this.repaint();

			myReturn = true;
		}
		
		return myReturn;
	}

	public void update(Graphics g){
		if(firstinit){
			paint(g);
		}else{
	
			doublebufferG.setFont(ftStandard);
			doublebufferG.setColor(colBackground);
			doublebufferG.fillRect(0, 0, width,  dblbuffer_Height);
		
			if(pic != null){
				doublebufferG.drawImage(pic, 0, 0, this);
			}
		
//			active c = (active)vActive.elementAt(0);
//			System.out.println("fill: x:"+c.x1+" x2:"+c.x2+" y1:"+c.y1+" y2:"+c.y2);
//			doublebufferG.fillRect(c.x1, c.y1, c.x2-c.x1,  c.y2-c.y1);
	
			doublebufferG.setColor(colFont);
		
			//text schreiben
		
//			doublebufferG.setFont(new Font("Arial", 3, 14));
//			doublebufferG.drawString(news.elementAt(0).toString(), 5, drawPos);

			for(int ln=0; ln < vLines.size(); ln++){
				Line l = (Line)vLines.elementAt(ln);
				if(l.isURL){
					doublebufferG.setFont(ftURL);
					
					if(l.isSelected)
						doublebufferG.setColor(colHighlitedURL);
					else
						doublebufferG.setColor(colURL);
				}else if(l.isTitle){
					doublebufferG.setFont(ftTitle);
					doublebufferG.setColor(colTitle);
				}else{
					doublebufferG.setFont(ftStandard);
					doublebufferG.setColor(colFont);
				}
				
				doublebufferG.drawString(l.strText, l.x1, intDrawPos + ln * lineHeight);
			}

			paint(g);
			System.gc();
		}
	}


	public void paint(Graphics g){
		if(firstinit){
			if(sepInit(g)){
				repaint();
			}else{
				return;
			}
		}else{
			g.drawImage(dblbuffer, 0, 0, this);
			System.gc();
		}
	}
	
	public void stop(){
		frame = null;
	}
	
	public void start(){
		if(frame == null){
			frame = new Thread(this);
		}
	}

	
	private int readNews(Vector vLines){
		int lineCnt=0;	
		StringTokenizer st = null;
		try{
			java.net.URL inUrl = new java.net.URL(getDocumentBase(), getParameter("newsfile"));
			DataInputStream dis = new DataInputStream(inUrl.openStream());
        
			String inputLine, line1, line2;
			String prevLine;
			
			boolean endLine = false;
			boolean endRead = false;
			boolean readfromfile = true;

			while((inputLine = dis.readLine()) != null){
				lineCnt++;
				
				//Parsing HTML Tags
				
				int intHREFIndex = inputLine.indexOf("<a href='");
				int intTitleIndex = inputLine.indexOf("<title>");
				
				if(intHREFIndex != -1){

					intHREFIndex = inputLine.indexOf("'>") + 2;
					int intHREFIndex_ = inputLine.indexOf("</a>");

					String strText = inputLine.substring(intHREFIndex, intHREFIndex_);

					intHREFIndex  = inputLine.indexOf("<a href='") + 9;
					intHREFIndex_ = inputLine.indexOf("' t");

					String strURL = inputLine.substring(intHREFIndex, intHREFIndex_);

					intHREFIndex  = inputLine.indexOf("target='") + 8;
					intHREFIndex_ = inputLine.indexOf("'>");

					String strTarget = inputLine.substring(intHREFIndex, intHREFIndex_);
					
					//System.out.println(strText + "  " + strURL);
					
					//Adding the active element to the active list
//					System.out.println("lineh:" + lineHeight);
//					System.out.println("h:" + lineHeight * lineCnt);
					int hh = lineHeight * (lineCnt -2);
					int xx =  fm.stringWidth(strText);
					
					vLines.addElement(new Line(intLeftSpace, hh, xx, hh + lineHeight,strText, true, strURL, strTarget));
				}else if(intTitleIndex != -1){
					vLines.addElement(new Line(intLeftSpace, inputLine.substring(intTitleIndex + 7, inputLine.length()), true));
				}else{
					vLines.addElement(new Line(intLeftSpace, inputLine, false));
				}
			}
			lineCnt ++;
			vLines.addElement(new Line(intLeftSpace, "", false));
			lineCnt ++;
			String strUnregistered = "Unregistered - (C) Swissource";
			int hh = lineHeight * (lineCnt -2);
			int xx =  fm.stringWidth(strUnregistered);

			//Unregistered!!!!!!!			
			vLines.addElement(new Line(intLeftSpace, hh, xx, hh + lineHeight,strUnregistered, true, "http://www.swissource.ch", "_blank"));
			
			dis.close();
		}catch(Exception me){System.out.println(me);}
		
		return lineCnt;
	}
	
	class Line {
	
		int x1, y1, x2, y2;
		String strTarget;
		String strURL;
		String strText;
		
		boolean isURL = false;
		boolean isActive = false;
		boolean isSelected = false;
		boolean isTitle = false;
	
		public Line(int x1, int y1, int x2, int y2, String strText, boolean isURL, String strURL, String strTarget){
			this.x1 = x1;
			this.y1 = y1;
			this.x2 = x2;
			this.y2 = y2;
			this.strText = strText;
			this.isURL = isURL;
			this.strURL = strURL;
			this.strTarget = strTarget;
		}

		public Line(int x1, String strText, boolean isTitle){
			this.x1 = x1;
			this.strText = strText;
			this.isTitle = isTitle;
		}
		
		public void setSelected(boolean isSelected){
			this.isSelected = isSelected;
		}

		public boolean isMouseOver(Event e, int intDrawPos){
			boolean myReturn = false;
			
			if((this.x1 < e.x) && (e.x < this.x2) && ((this.y1 + intDrawPos) < e.y) && (e.y < (this.y2 + intDrawPos))){
				myReturn = true;
			}
			
			return myReturn;
		}
	}
	
	
}

